/*******************************************************************************
**  FILE:           qtocllibclasses.h   
**  DESCRIPTION:    This file is responsible for doing all of the forward 
**                  declarations for the classes in this library.
**
**
**  AUTHOR:	    Colter McQuay
**  ORGANIZATION:   University Of Victoria
**  SUPERVISOR:	    Dr. Poman So
**
*******************************************************************************/

#ifndef QTOCLLIBCLASSES_H
#define QTOCLLIBCLASSES_H
#include "QtOclMesh_global.h"

// Base classes
class Mesh;
class MeshItem;
class MeshEngine;
class MeshBoundary;

// Derived classes
class BoundaryMeshItem;
class MaterialMeshItem;
class ProbeMeshItem;
class SourceMeshItem;

class MeshBoundary;
class MeshException;

class NodeDescription;
class MeshSimulationThread;

#endif // QTOCLLIBCLASSES_H

