/*******************************************************************************
**  FILE:           
**  DESCRIPTION:    
**
**
**
**  AUTHOR:         Colter McQuay
**  ORGANIZATION:   University Of Victoria
**  SUPERVISOR:     Dr. Poman So
**
*******************************************************************************/

#include "animator.h"
#include "animatorglwidget.h"
#include "UI/MeshSimulator/meshsimulator.h"
#include "meshengine.h"

//-----------------------------------------------------------------------------
// CONSTRUCTORS / DESTRUCTORS
//-----------------------------------------------------------------------------


Animator::Animator(QWidget *parent)
  : QWidget(parent)
  , glAnimator_ (new AnimatorGLWidget(this))
  , mainLayout_ (new QGridLayout)
{
  setAttribute(Qt::WA_DeleteOnClose);
  setWindowProperties();


  setLayout(mainLayout_);
  mainLayout_->addWidget(glAnimator_,0,0);
  renderTimer_.start();
}


Animator::~Animator()
{
}



//-----------------------------------------------------------------------------
// PRIVATE METHODS
//-----------------------------------------------------------------------------



void
Animator::setWindowProperties()
{
    setWindowTitle(tr("Animator"));
    setWindowState(Qt::WindowNoState);

    Qt::WindowFlags flags = 0;
    flags |= Qt::SubWindow;
    flags ^= Qt::WindowCloseButtonHint;
    flags |= Qt::WindowMinMaxButtonsHint;

    setWindowFlags(flags);
}



//-----------------------------------------------------------------------------
// PUBLIC SLOTS
//-----------------------------------------------------------------------------


void Animator::updateAnimation(MeshEngine *meshEngine)
{
  if(renderTimer_.elapsed() > 50){
    renderTimer_.start();
    glAnimator_->updateAnimation(meshEngine);
  }
}
