#include "commands.h"
//
//
//// MOVE COMMAND
//
//MoveCommand::MoveCommand(MeshScene* initMeshScene, const QPointF &oldPos, QUndoCommand *parent)
//    : QUndoCommand(parent)
//{
//    meshScene = initMeshScene;
//    meshItemList = meshScene->selectedItems();
//    newPosition = getTopLeft(meshItemList);
//    oldPosition = oldPos;
//}
//void MoveCommand::undo(){
//    moveItemsTo(meshItemList,oldPosition);
//    setText(QObject::tr("Move %1").arg("item"));
//}
//void MoveCommand::redo(){
//    moveItemsTo(meshItemList,newPosition);
//    setText(QObject::tr("Move %1").arg("item"));
//}
//
//// DELETE COMMAND
//
//DeleteCommand::DeleteCommand(MeshScene *initMeshScene, QUndoCommand *parent)
//    :QUndoCommand(parent)
//{
//    meshScene = initMeshScene;
//    meshItemList = meshScene->selectedItems();
//    setText(QObject::tr("Delete %1")
//            .arg("Item"));
//}
//void DeleteCommand::undo(){
//    meshScene->selectedItemGroup->removeAllFromGroup();
//    foreach(MeshGraphicsItem* meshItemPtr,meshItemList){
//        meshScene->addItem(meshItemPtr);
//        meshItemPtr->setSelected(true);
//        meshScene->selectedItemGroup->addToGroup(meshItemPtr);
//    }
//    meshScene->update();
//
//}
//void DeleteCommand::redo(){
//    foreach(MeshGraphicsItem* meshItemPtr,meshItemList){
//        meshScene->removeItem(meshItemPtr);
//    }
//}
//
//// INSERT COMMAND
//
//InsertCommand::InsertCommand(MeshScene *initMeshScene,MeshGraphicsItem* item, QUndoCommand *parent)
//    :QUndoCommand(parent)
//{
//    meshScene = initMeshScene;
//    meshItem = item;
//    setText(QObject::tr("Insert %1")
//            .arg("Item"));
//
//}
//void InsertCommand::undo(){
//    meshScene->removeItem(meshItem);
//}
//void InsertCommand::redo(){
//    meshScene->addItem(meshItem);
//    meshScene->clearSelectedItemGroup();
//    meshScene->addItemToSelectedGroup(meshItem);
//}
//
//// SCALE COMMAND
//
//ScaleCommand::ScaleCommand(MeshScene* initMeshScene, const QSizeF &initScaleAmmount, QUndoCommand *parent)
//    : QUndoCommand(parent)
//{
//    meshScene = initMeshScene;
//    meshItemList = meshScene->selectedItems();
//    newSize = meshScene->mapToMesh(meshScene->getSelectionRect()).size();
//    scaleAmmount = initScaleAmmount;
//    setText(QObject::tr("Scale %1").arg("item"));
//}
//void ScaleCommand::undo(){
//    meshScene->clearSelectedItemGroup();
//    meshScene->addItemsToSelectedGroup(meshItemList);
//    meshScene->selectedItemGroup->adjustSize(QSizeF(0,0)-scaleAmmount);
//}
//void ScaleCommand::redo(){
//    if(newSize!=meshScene->mapToMesh(meshScene->getSelectionRect()).size()){
//        meshScene->clearSelectedItemGroup();
//        meshScene->addItemsToSelectedGroup(meshItemList);
//        meshScene->selectedItemGroup->adjustSize(scaleAmmount);
//    }
//}
//
//// CHANGE REFLECTION COEFFICIENT COMMAND
//
//ChangeReflectionCoefCommand::ChangeReflectionCoefCommand
//	(MeshScene* initMeshScene,QList<MeshGraphicsItem *>initItemList,
//	 float reflectionCoef,QUndoCommand *parent){
//    meshScene = initMeshScene;
//    meshItemList = initItemList;
//    foreach(MeshGraphicsItem* meshItemPtr,meshItemList){
//	oldReflectionCoef.append(meshItemPtr->getReflectionCoef());
//    }
//    newReflectionCoef = reflectionCoef;
//    setText(QObject::tr("Change Reflection Coefficient"));
//}
//void ChangeReflectionCoefCommand::redo(){
//    foreach(MeshGraphicsItem* meshItemPtr,meshItemList){
//	meshItemPtr->setReflectionCoef(newReflectionCoef);
//    }
//    meshScene->clearSelectedItemGroup();
//    meshScene->addItemsToSelectedGroup(meshItemList);
//}
//void ChangeReflectionCoefCommand::undo(){
//    foreach(MeshGraphicsItem* meshItemPtr,meshItemList){
//	meshItemPtr->setReflectionCoef(oldReflectionCoef.at(meshItemList.indexOf(meshItemPtr)));
//    }
//    meshScene->clearSelectedItemGroup();
//    meshScene->addItemsToSelectedGroup(meshItemList);
//}
//
//
//// CHANGE REL PERMITTIVITY COMMAND
//
//ChangeRelPermittivityCommand::ChangeRelPermittivityCommand
//	(MeshScene* initMeshScene,QList<MeshGraphicsItem *>initItemList,
//	 float relPermittivity,QUndoCommand *parent){
//    meshScene = initMeshScene;
//    meshItemList = initItemList;
//    foreach(MeshGraphicsItem* meshItemPtr,meshItemList){
//	oldRelPermittivity.append(meshItemPtr->getRelativePermittivity());
//    }
//    newRelPermittivity = relPermittivity;
//    setText(QObject::tr("Change Relative Permittivity"));
//}
//void ChangeRelPermittivityCommand::redo(){
//    foreach(MeshGraphicsItem* meshItemPtr,meshItemList){
//	meshItemPtr->setRelativePermittivity(newRelPermittivity);
//    }
//    meshScene->clearSelectedItemGroup();
//    meshScene->addItemsToSelectedGroup(meshItemList);
//}
//void ChangeRelPermittivityCommand::undo(){
//    foreach(MeshGraphicsItem* meshItemPtr,meshItemList){
//	meshItemPtr->setRelativePermittivity(oldRelPermittivity.at(meshItemList.indexOf(meshItemPtr)));
//    }
//    meshScene->clearSelectedItemGroup();
//    meshScene->addItemsToSelectedGroup(meshItemList);
//}
//
//
//// CHANGE CONDUCTANCE COMMAND
//
//ChangeConductanceCommand::ChangeConductanceCommand
//	(MeshScene* initMeshScene,QList<MeshGraphicsItem *>initItemList,
//	 float conductance,QUndoCommand *parent){
//    meshScene = initMeshScene;
//    meshItemList = initItemList;
//    foreach(MeshGraphicsItem* meshItemPtr,meshItemList){
//	oldConductance.append(meshItemPtr->getConductance());
//    }
//    newConductance = conductance;
//    setText(QObject::tr("Change Conductance"));
//}
//void ChangeConductanceCommand::redo(){
//    foreach(MeshGraphicsItem* meshItemPtr,meshItemList){
//	meshItemPtr->setConductance(newConductance);
//    }
//    meshScene->clearSelectedItemGroup();
//    meshScene->addItemsToSelectedGroup(meshItemList);
//}
//void ChangeConductanceCommand::undo(){
//    foreach(MeshGraphicsItem* meshItemPtr,meshItemList){
//	meshItemPtr->setConductance(oldConductance.at(meshItemList.indexOf(meshItemPtr)));
//    }
//    meshScene->clearSelectedItemGroup();
//    meshScene->addItemsToSelectedGroup(meshItemList);
//}
//
