/*******************************************************************************
**  FILE:
**  DESCRIPTION:
**
**
**  AUTHOR:	    Colter McQuay
**  ORGANIZATION:   University Of Victoria
**  SUPERVISOR:	    Dr. Poman So
**
*******************************************************************************/

#ifndef EDITORVIEW3D_H
#define EDITORVIEW3D_H
#include "editorview.h"

class EditorView3D : public EditorView
{
  Q_OBJECT
private:
  QPoint  mouseStartPos;
  QPoint  mouseCurrentPos;
  float   elevation_;
  float   azimuth_;
  float   distance_;

public:
  explicit EditorView3D(Editor* parent);
  virtual void setupGLView(QSize viewSize);

  void adjustElevation(const float deltaElevation);
  void adjustAzimuth(const float deltaAzimuth);
  void adjustDistance(const float deltaDistance);

  void setElevation(const float elevation);
  void setAzimuth(const float azimuth);
  void setDistance(const float distance);

protected:
  bool eventFilter(QObject * object, QEvent *event);
//  void mousePressEvent(QMouseEvent * mouseEvent);
//  void mouseMoveEvent(QMouseEvent * mouseEvent);
//  void mouseReleaseEvent(QMouseEvent * mouseEvent);
  void wheelEvent(QWheelEvent *wheelEvent);

private:
  void adjustCameraPosition();

signals:
  void mousePressed(const QPoint mousePos,
                    Qt::MouseButtons buttons,
                    Qt::KeyboardModifiers modifiers);

public slots:

};

#endif // EDITORVIEW3D_H
