/*******************************************************************************
**  FILE:
**  DESCRIPTION:
**
**
**  AUTHOR:	    Colter McQuay
**  ORGANIZATION:   University Of Victoria
**  SUPERVISOR:	    Dr. Poman So
**
*******************************************************************************/

#ifndef MESHITEMLISTSELECTOR_H
#define MESHITEMLISTSELECTOR_H
#include "meshitemselector.h"
#include <QtGui>

class MeshItemListSelector : public MeshItemSelector
{
    Q_OBJECT
private:
  QTreeWidget* itemListWidget;
public:
  explicit MeshItemListSelector(QList<MeshItem*> itemList, QWidget *parent = 0);

protected:
  void createMeshItemView();
private:
  QTreeWidgetItem*
      createMeshItemListItem(QTreeWidgetItem* parent, MeshItem* item,
                             QList<MeshItemProperty>& commonProperties) const;
  QTreeWidgetItem*
  createMeshPropertyListItem(QTreeWidgetItem* parentItem,
                             MeshItemProperty meshItemProperty)const;
  QTreeWidgetItem*
      createCommonPropertiesListItem(QTreeWidgetItem* parent,
                                     QList<MeshItemProperty>& commonProperties) const;
  QMap<QString,QVariant> getListItemProperties(QTreeWidgetItem* selectedItem) const;
  QVariant getListItemPropertyValue(QTreeWidgetItem* propertyListItem) const;

public slots:
  void syncItemViewProperties(QList<MeshItem*> items);
  void clearItemViewSelection();

private slots:
  void meshItemListSelect();
  void meshItemListEdited(QTreeWidgetItem* listItem, int col);

};

#endif // MESHITEMLISTSELECTOR_H
