///*******************************************************************************
//**  FILE:
//**  DESCRIPTION:
//**
//**
//**  AUTHOR:	    Colter McQuay
//**  ORGANIZATION:   University Of Victoria
//**  SUPERVISOR:	    Dr. Poman So
//**
//*******************************************************************************/

//#include "meshviewrenderthread.h"
//#include "meshviewgl.h"
//#include "qtoclmesh.h"
//#include "pointmappergl.h"


////-----------------------------------------------------------------------------
////  CONSTRUCTORS / DESTRUCTORS
////-----------------------------------------------------------------------------


//MeshViewRenderThread::MeshViewRenderThread(MeshViewGL &view) :
//    QThread       (),
//    meshView_     (view),
//    pointMapper_  (view.getPointMapper()),
//    renderFlag_   (true),
//    resizeFlag_   (false),
//    viewPortSize_ (view.size())
//{
//}



//MeshViewRenderThread::~MeshViewRenderThread()
//{
//  if(isRunning()){
//    stop();
//  }
//}



////-----------------------------------------------------------------------------
////  PUBLIC METHODS
////-----------------------------------------------------------------------------


//void
//MeshViewRenderThread::resizeViewport(const QSize &size)
//{
//  viewPortSize_ = size;
//  resizeFlag_   = true;
//}



//void
//MeshViewRenderThread::stop()
//{
//  renderFlag_ = false;
//  meshView_.renderCondition().wakeAll();
//  wait();
//}



//MeshItem*
//MeshViewRenderThread::pickItem(const QPoint& pos)
//{
//  meshItems_ = meshView_.getMeshItemList();
//  meshView_.lockGLContext();

//  const int HIT_BUFFER_SIZE = 512;
//  GLuint hitBuffer[HIT_BUFFER_SIZE];
//  GLint viewport[4];

//  glGetIntegerv(GL_VIEWPORT, viewport);
//  glSelectBuffer(HIT_BUFFER_SIZE, hitBuffer);
//  // enter select mode
//  glRenderMode(GL_SELECT);

//  glInitNames();
//  glPushName(-1);

//  glMatrixMode(GL_PROJECTION);
//  glPushMatrix();
//  glLoadIdentity();
//  gluPickMatrix((GLdouble)pos.x(),
//                (GLdouble)(viewport[3] - pos.y()),
//                5.0, 5.0, viewport);
//  meshView_.setupGLView(viewPortSize_);
//  draw();
//  glMatrixMode(GL_PROJECTION);
//  glPopMatrix();

//  GLint hits = glRenderMode(GL_RENDER);

//  // finally release the rendering context again
//  if (hits == 0)
//  {
//      meshView_.unlockGLContext();
//      return 0;
//  }
//  meshView_.unlockGLContext();

//  int hitEntry;
//  int closestName = hitBuffer[3];
//  int closestDepth    = hitBuffer[1];
//  for(int i = 1; i < hits; ++i){
//    hitEntry = i*4;
//    if(hitBuffer[hitEntry+1]<closestDepth){
//      closestDepth = hitBuffer[hitEntry+1];
//      closestName = hitBuffer[hitEntry+3];
//    }
//  }

//  // return the name of the clicked surface
//  return meshItems_.at(closestName);
//}


////-----------------------------------------------------------------------------
////  PROTECTED METHODS
////-----------------------------------------------------------------------------


//void
//MeshViewRenderThread::run()
//{
//  // Locks the render Mutex of the GL widget.
//  // Also makes the GL context current in this thread
//  meshView_.lockGLContext();

//  initializeGL();

//  while(renderFlag_){

//    if(resizeFlag_){
//      resizeGL(viewPortSize_.width(), viewPortSize_.height());
//      resizeFlag_ = false;
//    }

//    paintGL();

//    meshView_.swapBuffers();

//    // Need to release the OpenGL context so that we can pick items
//    meshView_.doneCurrent();

//    meshView_.renderCondition().wait(&meshView_.renderMutex());

//    // Get the OpenGL context back from the meshView object
//    meshView_.makeCurrent();


//  }
//  // Release and unlock the openGL context and render mutex before exit
//  meshView_.unlockGLContext();
//}



//void
//MeshViewRenderThread::initializeGL()
//{
//  lightList_ = meshView_.getMeshLights();

//  glClearColor(1.0, 1.0, 1.0, 0.0);

//  glEnable(GL_LIGHTING);
//  GLfloat ambientLight[] = { 0.3f, 0.3f, 0.3f, 1.0f };
//  glLightModelfv(GL_LIGHT_MODEL_AMBIENT, ambientLight);

//  if(lightList_.count()>0){

//    foreach(MeshLight* light, lightList_){
//      glEnable(light->glLight);
//      glLightfv(light->glLight, GL_DIFFUSE, light->diffuse);
//      glLightfv(light->glLight, GL_SPECULAR, light->specular);
//      glLightfv(light->glLight, GL_AMBIENT, light->ambient);
//    }


//    //glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,0);
//    glEnable(GL_COLOR_MATERIAL);
//    glColorMaterial(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE | GL_SPECULAR);

//    float specReflection[] = { 0.1f, 0.1f, 0.1f, 1.0f };
//    glMaterialfv(GL_FRONT, GL_SPECULAR, specReflection);
//    glMateriali(GL_FRONT, GL_SHININESS, 96);

////    float black[4]={.05,.05,.05,0.05};
////    float white[4]={0.1,0.1,0.1,0.1};
////    glMaterialfv(GL_FRONT,GL_AMBIENT,black);
////    glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,white);
//  }

//  // ALIASING AND FILLING SETTINGS
//  glShadeModel(GL_SMOOTH);
//  glEnable(GL_DEPTH_TEST);
//  glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
//  glEnable(GL_BLEND);
//  glEnable(GL_LINE_SMOOTH);
//  glEnable(GL_POINT_SMOOTH);
//  glFrontFace(GL_CCW);
//}



//void
//MeshViewRenderThread::resizeGL(int width, int height)
//{
//  // SET UP THE PROJECTION MATRIX
//  glMatrixMode(GL_PROJECTION);
//  glLoadIdentity();

//  meshView_.setupGLView(QSize(width,height));

//  glMatrixMode(GL_MODELVIEW);
//  glViewport(0, 0, width, height);

//  emit viewPortResized(QSize(width,height));
//}



//void
//MeshViewRenderThread::paintGL()
//{
//    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
//    draw();
//}




////-----------------------------------------------------------------------------
////  PRIVATE METHODS
////-----------------------------------------------------------------------------


//void
//MeshViewRenderThread::draw()
//{
//  QList<MeshItem*> itemList_   = meshView_.getMeshItemList();
//  Point3D<GLfloat> rotation_      = meshView_.getRotation();
//  Point3D<GLfloat> cameraPos_     = meshView_.getCameraPos();
//  GLfloat cameraDistance_         = meshView_.getCameraDistance();
//  Point3D<GLfloat> cameraAt_      = meshView_.getCameraAt();
//  Point3D<GLfloat> cameraUp_      = meshView_.getCameraUp();
//  bool  gridVisible_              = pointMapper_.gridVisible();


//  // TRANSFORMS
//  glMatrixMode(GL_MODELVIEW);
//  glLoadIdentity();



//  // Set up camera - Move cameraDistance_ away from origin, rotate
//  // accordingly to provide the appropriate point of view
//  //glTranslatef(0.0, 0.0, -cameraDistance_);
//  //    glRotatef(rotation_.cx(), 1.0, 0.0, 0.0);
//  //    glRotatef(rotation_.cy(), 0.0, 1.0, 0.0);
//  //    glRotatef(rotation_.cz(), 0.0, 0.0, 1.0);
//  //    glTranslatef(-cameraPos_.cx(), -cameraPos_.cy(), -cameraPos_.cz());
//  gluLookAt(cameraPos_.cx(),cameraPos_.cy(),cameraPos_.cz(),
//            cameraAt_.cx(),cameraAt_.cy(),cameraAt_.cz(),
//            cameraUp_.cx(),cameraUp_.cy(),cameraUp_.cz());

//  // Adjust light position so that the items are consistantly lit
//  foreach(MeshLight* light, lightList_){
//    glLightfv(light->glLight, GL_POSITION, light->pos);
//  }


//  if(gridVisible_){
//    //    drawG
//  }

//  if(pointMapper_.mouseTracker.pressPositionsVisible()){
//    drawPressPoints();
//  }


//  //    glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
//  //    glLineWidth(3);
//  if(itemList_.count()>0){
//    for(int i = 0;i<itemList_.count();++i){
//      glLoadName(i);
//      itemList_.at(i)->draw();
//    }
//  }

//}


//void
//MeshViewRenderThread::initGridEvaluator()
//{
//    glEnable(GL_MAP2_VERTEX_3);
//    glEnable(GL_AUTO_NORMAL);
//    glMapGrid2f(200,0.0,1.0,200,0.0,1.0);

//    meshControlPoints[0][0][0] = 0.0;
//    meshControlPoints[0][0][1] = 0.0;
//    meshControlPoints[0][0][2] = 0.0;

//    meshControlPoints[0][1][0] = 1.0;
//    meshControlPoints[0][1][1] = 0.0;
//    meshControlPoints[0][1][2] = 0.0;

//    meshControlPoints[1][0][0] = 0.0;
//    meshControlPoints[1][0][1] = 1.0;
//    meshControlPoints[1][0][2] = 0.0;

//    meshControlPoints[1][1][0] = 1.0;
//    meshControlPoints[1][1][1] = 1.0;
//    meshControlPoints[1][1][2] = 0.0;
//}



//void
//MeshViewRenderThread::drawGrid()
//{
//  initGridEvaluator();
////  glMatrixMode(GL_PROJECTION);
////  glPushMatrix();
////  glOrtho(0,1,0,1,0.01,10);
//  glMatrixMode(GL_MODELVIEW);
//  glPushMatrix();
//  glLoadIdentity();
////  glDisable(GL_DEPTH_TEST);
////  glPointSize(0.2);
////  glLineWidth(0.2);
//  glColor3f(0.0,0.0,0.0);
//  glMap2f(GL_MAP2_VERTEX_3,
//          0.0, 1.0,   // domain
//          3,          // stride
//          2,          // order
//          0.0, 1.0,   // range
//          2 * 3,      // stride
//          2,          // order
//          &meshControlPoints[0][0][0]);
//  glEvalMesh2(GL_LINE,0,200,0,200);
////  glEnable(GL_DEPTH_TEST);
//  glPopMatrix();
//  glMatrixMode(GL_PROJECTION);
//  glPopMatrix();
//}



//void
//MeshViewRenderThread::drawPressPoints()
//{
//  QVector< Point3D<float> > pointsToDraw;
//  pointsToDraw << pointMapper_.mouseTracker.getLastPressPosition();
//  pointsToDraw << pointMapper_.mouseTracker.getPressPosition();

//  glPointSize(2);
//  glColor3f(0.9, 0.0, 0.0);
//  glBegin(GL_POINTS);
//  foreach(Point3D<float> point, pointsToDraw){
//    glVertex3f(point.cx(),point.cy(), point.cz());
//  }
//  glEnd();
//  glPointSize(1);
//}
